/*
Usage:
to compile:
	javac HaikuChecker.java
to run:
	java HaikuChecker this is not a haiku
	or
	java HaikuChecker this should be a haiku if i counted correctly you should try it



*/


import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;


public class HaikuChecker{
	public static String guiOut;
	public static void main(String args[]){
		int sum = 0;
		for(int i=0; i<args.length; i++){	
			sum += numSyllables(removePunc(args[i]));
		}
		System.out.println("Number of Syllables: " + sum);
		if(sum == 17) System.out.println("--- It's a Haiku ----");
	}
	
	public static int countString(String s, TextArea output){
		StringTokenizer st = new StringTokenizer(s);
		guiOut = "";
		int sum = 0;
		int x;
		String token;
		while(st.hasMoreTokens()){
			token = removePunc(st.nextToken());
			x = numSyllables(removePunc(token));
			guiOut += token + ": " + x + "\n";
			sum += x;
		}
		System.out.println("Number of Syllables: " + sum);
		guiOut += "Number of Syllables: " + sum;
		
		if(sum == 17){
			guiOut += "--- It's a Haiku ----" + "\n";
			System.out.println("--- It's a Haiku ----");
		}
		
		output.setText(guiOut);	
		return sum;
	}
	
	
	public static String removePunc(String s){
		s = s.toLowerCase();
		s = s.replaceAll("[^a-z]*", "");
		return s;
	}
	
	public static int numSyllables(String theWord){
		Vector v = new Vector();
		boolean debug = true;
		boolean doneWithLine = false;
		String s = "";
		String s2 = "";
		String splitTemp[], splitTemp2[];
		theWord = (new String(theWord)).toLowerCase();
		String foundWord = "";
		String foundWordStripped = "";
		boolean found = false;
		int count = 0;
			
		//if(debug) System.out.println("looking up: " + theWord);
			
		try{
			URL wordLink = new URL("http://dictionary.reference.com/search?q=" + theWord);
			URLConnection connection = wordLink.openConnection();
			BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));

			while( (s = in.readLine()) != null && !found){
				s = s.toLowerCase();
				if(s.matches(".*?<b>.*?")){
					splitTemp = s.split("<b>");
					//System.out.println("length: " + splitTemp.length);
					for(int p=0; p<splitTemp.length; p++){
						//System.out.println(splitTemp[p]);
						//System.out.println();
					
					
						splitTemp2 = (splitTemp[p]).split("</b>");
						s = splitTemp2[0];
						if(!s.matches(".*?[<|>].*?")){
							if(s.endsWith(",")) s = s.substring(0, s.length() - 1);
							v.add(s);
						}
					}
				} else if (s.startsWith("<!-- begin web1913 -->")){
					break;
				}
			}	
		} catch (Exception e){
			System.out.println(e);
		}
		
		System.out.println(v);
		
		boolean moreSearching = true;
		boolean foundOnce = false;
		int pointer=0;
		while(moreSearching){
			s = (String) v.elementAt(pointer);
			if(s.equals(theWord)){
				foundOnce = true;
			} else {
				Vector x = removeBreaks(s);
				//System.out.println("'" + s + "' vs. '" + (String)x.elementAt(0) + ", with count = " + (Integer) x.elementAt(1));
				if(theWord.equals((String)x.elementAt(0))){
					count = ((Integer) x.elementAt(1)).intValue() + 1;
					moreSearching = false;
				} else {
					
				}
			}
			
			if(pointer>=v.size()){
				moreSearching = false;
			}
			
			if(pointer == v.size() - 1){
				if(foundOnce){
					count = 1;	
				} else {
					System.out.println("Error! Could not find word: " + theWord);
					guiOut += "Error! Could not find word: " + theWord + "\n";
				
					count = 0;
				}
				foundOnce = false;
				break;
			}
			pointer++;
		}
	
		System.out.println(theWord + ": " + count);
		return count;
	}
		
	public static Vector removeBreaks(String s){
		int tc = 0;
		String tempString1, tempString2;
		tempString1 = s;
		tempString2 = s;
		boolean doneSplit = false;
		
		while(!doneSplit){
			//System.out.println("TS1 = " + tempString1 + ", TS2 = " + tempString2 + ", c=" + tc);
			tempString2 = tempString1.replaceFirst("&#183;", "");
			if(tempString2.equals(tempString1)){
				doneSplit = true;
				s = tempString1;
				break;
			} else {
				tc++;
				tempString1 = tempString2;
			}
		}
		
		Vector u = new Vector();
		u.add(s.trim());
		u.add(new Integer(tc));
		
		return u;
	}
}